Developer Documentation

Public Slots | Signals | Public Member Functions | Private Slots | Private Member Functions | Private Attributes | List of all members
HoleFillerPlugin Class Reference
Inheritance diagram for HoleFillerPlugin:

## Public Slots
void | fillAllHoles (int _objectID)
| fill all holes from a given object
void | fillHole (int _objectID, int _edgeHandle)
| fill a hole in given object where _edgeHandle is on the boundary
QString | version ()

## Signals
void | updateView ()
void | updatedObject (int _id, const UpdateType &_type)
void | addPickMode (const std::string &_mode)
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | createBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
void | scriptInfo (QString _functionName)
void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from PickingInterface
virtual void | addPickMode (const std::string &_mode)
| Add a new picking mode to the examiner. More...
Signals inherited from ToolboxInterface
virtual void | addToolbox (QString _name, QWidget *_widget)
| Add a toolbox widget to the gui with the given name. More...
Signals inherited from LoggingInterface
virtual void | log (Logtype _type, QString _message)=0
virtual void | log (QString _message)=0
Signals inherited from ScriptInterface
virtual void | scriptInfo (QString _functionWithParameters)
| Emit this signal if a scriptable function is executed. More...
virtual void | getScriptingEngine (QScriptEngine *&_engine)
virtual void | executeScript (QString _script)
virtual void | getAvailableFunctions (QStringList &_functions)
Signals inherited from BackupInterface
virtual void | createBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
| Tell Backup Plugin to create a backup. More...
virtual void | aboutToRestore (int _objectid)
| Backup Plugin tells other Plugins that a restore will happen. More...
virtual void | generateBackup (int _id, QString _name, UpdateType _type)
| This signal is emitted by a BackupPlugin and tells a TypePlugin to generate a backup. More...

## Public Member Functions
| HoleFillerPlugin ()
| Constructor.
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...

## Private Slots
void | slotObjectUpdated (int _identifier, const UpdateType &_type)
| check for holes if an object has changed
void | slotMouseWheelEvent (QWheelEvent *, const std::string &)
void | slotItemSelectionChanged ()
| slot for displaying selected holes
void | slotCellDoubleClicked (int _row, int _col)
| Slot for filling holes from double-clicked rows.
void | slotFillSelection ()
| Fill all selected holes.
void | noguiSupported ()
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...

## Private Member Functions
void | slotMouseEvent (QMouseEvent *)
| Mouse Event from main application ( Picking Mode ) More...
void | initializePlugin ()
| Initialize the toolbox widget.
void | pluginsInitialized ()
| add PickModes after initialization
void | detectButton ()
| detect holes on all objects
void | update_menu ()
| update the entries in the tableWidget
void | getSelectedHoles (std::vector< int > &_holeIds, std::vector< int > &_objIds)
| get a map from objectID to (selected) holeIDs
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from MouseInterface
virtual | ~MouseInterface ()
| Destructor.
Private Member Functions inherited from PickingInterface
virtual void | addHiddenPickMode (const std::string &_mode)
| Add a new picking mode to the examiner which will be invisible. More...
virtual void | setPickModeCursor (const std::string &_mode, QCursor _cursor)
| Set the cursor of the given PickMode. More...
virtual void | setPickModeMouseTracking (const std::string &_mode, bool _mouseTracking)
| Set mouse tracking for the given PickMode. More...
virtual void | setPickModeToolbar (const std::string &_mode, QToolBar *_toolbar)
| Set the additional toolbar of the given PickMode. More...
virtual void | removePickModeToolbar (const std::string &_mode)
| Removes the additional toolbar of the given PickMode. More...
virtual | ~PickingInterface ()
| Destructor.
Private Member Functions inherited from ToolboxInterface
virtual | ~ToolboxInterface ()
| Destructor.
virtual void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
| Add a toolbox widget to the gui with the given name and an icon. More...
virtual void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon, QWidget *_headerAreaWidget)
| Add a toolbox widget to the gui with the given name, icon and header area widget. More...
Private Member Functions inherited from LoggingInterface
virtual | ~LoggingInterface ()
| Destructor.
Private Member Functions inherited from ScriptInterface
virtual | ~ScriptInterface ()
| Destructor.
virtual void | executeFileScript (QString _filename)
virtual void | getDescription (QString _function, QString &_description, QStringList &_parameters, QStringList &_descriptions)
Private Member Functions inherited from BackupInterface
virtual void | createBackup (IdList _objectids, QString _name, std::vector< UpdateType > _types)
| Tell Backup Plugin to create a group backup. More...
virtual void | undo (int _objectid)
| Tell Backup Plugin to undo the last action of an object. More...
virtual void | redo (int _objectid)
| Tell Backup Plugin to redo the last action on an object. More...
virtual void | undo ()
| Tell Backup Plugin to undo the last action. More...
virtual void | redo ()
| Tell Backup Plugin to redo the last action. More...
virtual | ~BackupInterface ()
| Destructor.
virtual void | restored (int _objectid)
| Backup Plugin tells other Plugins that a restore has happened. More...
Private Member Functions inherited from PythonInterface
virtual | ~PythonInterface ()
| Destructor.

## Private Attributes
HoleFillerToolbarWidget * | tool_
| Widget for Toolbox.
std::vector< std::pair< int, int > > | holeMapping_
| map from the index in the table to (object-id, hole-id)

## Detailed Description

Definition at line 64 of file HoleFillerPlugin.hh.

## Member Function Documentation

## ◆ description()

QString HoleFillerPlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 118 of file HoleFillerPlugin.hh.

## ◆ name()

QString HoleFillerPlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 117 of file HoleFillerPlugin.hh.

## ◆ slotMouseEvent()

void HoleFillerPlugin::slotMouseEvent | ( | QMouseEvent * | _event | ) |
| inline private virtual

Mouse Event from main application ( Picking Mode )

This slot is called if a mouse event occurred in the Viewer This slot will only get called in pickingMode. Right button clicks will not be passed to the plugins as this is reserved for the context Menu.

Parameters

  _event | Mouse event

Reimplemented from MouseInterface.

Definition at line 103 of file HoleFillerPlugin.hh.

The documentation for this class was generated from the following files:

- Plugin-HoleFilling/HoleFillerPlugin.hh
- Plugin-HoleFilling/HoleFillerPlugin.cc